# GO UTILS GORM LOGGING PACKAGE

This package implements custom logger for gorm using zap.

## Log Levels

```text
debug -> info -> warn -> error -> panic -> fatal
```

## Example

```go
package main

import (
	"gitlab.com/bobble-public/backend/go-utils/logging"
	"gitlab.com/bobble-public/backend/go-utils/logging/gorm_logging"
	"gorm.io/driver/sqlite"
	"gorm.io/gorm"
	"time"
)

type Product struct {
	gorm.Model
	Code  string
	Price uint
}

func main() {
	gormLogger, err := gorm_logging.NewGormLogger("error")
	if err != nil {
		logging.Panic(err.Error())
	}
	gormLogger.SetSlowThreshold(500 * time.Microsecond) // defaults
	gormLogger.SetIgnoreRecordNotFoundError(true)       // defaults

	db, err := gorm.Open(sqlite.Open("test.db"), &gorm.Config{Logger: gormLogger})
	if err != nil {
		logging.Panic("failed to connect database")
	}

	// Migrate the schema
	db.AutoMigrate(&Product{})

	// Create
	db.Create(&Product{Code: "D42", Price: 100})

	// Read
	var product Product
	db.First(&product, 1)                 // find product with integer primary key
	db.First(&product, "code = ?", "D42") // find product with code D42

	// Update - update product's price to 200
	db.Debug().Model(&product).Update("Price", 200)
	// Update - update multiple fields
	db.Model(&product).Updates(Product{Price: 200, Code: "F42"}) // non-zero fields
	db.Model(&product).Updates(map[string]interface{}{"Price": 200, "Code": "F42"})

	// Delete - delete product
	db.Delete(&product, 1)
}
```
